/*    
  This script dynamically adds a table of contents to a web page
  It was copied from here: 
  http://stackoverflow.com/questions/187619/is-there-a-javascript-solution-to-generating-a-table-of-contents-for-a-page

  To use this script do the following:
  1) include the script within the <head> section of your html page, e.g.

  <script src="./doc_toc.js" type="text/javascript"></script>

  2) Add an empty <div> with id="toc" to the body of the html page 
     that this script will fill out with the TOC:

  <div id="toc"></div>

  3) Place the content of the html page within a <div> with id="contents", e.g.

  <div id="contents">
  ....
  </div>

*/
window.onload = function () {
    var toc = "<h2>Table of Contents</h2>";
    var level = 0;
    document.getElementById("contents").innerHTML =
    document.getElementById("contents").innerHTML.replace(
	/<h([\d])>([^<]+)<\/h([\d])>/gi,
	function (str, openLevel, titleText, closeLevel) {
	    if (openLevel != closeLevel) {return str; }
	    if (openLevel > level) {
		toc += (new Array(openLevel - level + 1)).join("<ul>");
	    } else if (openLevel < level) {
		toc += (new Array(level - openLevel + 1)).join("</ul>");
	    }
	    level = parseInt(openLevel);
	    var anchor = titleText.replace(/ /g, "_");
	    toc += "<li><a href=\"#" + anchor + "\">" + titleText
		 + "</a></li>";
	    return "<h" + openLevel + "><a name=\"" + anchor + "\">"
		 + titleText + "</a></h" + closeLevel + ">";
	}
    );
    if (level) {
	toc += (new Array(level + 1)).join("</ul>");
    }
    document.getElementById("toc").innerHTML += toc;
};
